con
_clkmode = xtal1 + pll8x
_xinfreq = 10_000_000

OBJ
  snd   : "NS_sound_drv_052_11khz_16bit.spin"   'Sound driver
  midi  : "fullduplexserial"
  tv    : "Piano draw"

DAT
lut     word snd#NOTE_C0, snd#NOTE_Cs0, snd#NOTE_D0, snd#NOTE_Ds0, snd#NOTE_E0, snd#NOTE_F0, snd#NOTE_Fs0, snd#NOTE_G0, snd#NOTE_Gs0, snd#NOTE_A0, snd#NOTE_As0, snd#NOTE_B0
        word snd#NOTE_C1, snd#NOTE_Cs1, snd#NOTE_D1, snd#NOTE_Ds1, snd#NOTE_E1, snd#NOTE_F1, snd#NOTE_Fs1, snd#NOTE_G1, snd#NOTE_Gs1, snd#NOTE_A1, snd#NOTE_As1, snd#NOTE_B1
        word snd#NOTE_C2, snd#NOTE_Cs2, snd#NOTE_D2, snd#NOTE_Ds2, snd#NOTE_E2, snd#NOTE_F2, snd#NOTE_Fs2, snd#NOTE_G2, snd#NOTE_Gs2, snd#NOTE_A2, snd#NOTE_As2, snd#NOTE_B2
        word snd#NOTE_C3, snd#NOTE_Cs3, snd#NOTE_D3, snd#NOTE_Ds3, snd#NOTE_E3, snd#NOTE_F3, snd#NOTE_Fs3, snd#NOTE_G3, snd#NOTE_Gs3, snd#NOTE_A3, snd#NOTE_As3, snd#NOTE_B3
        word snd#NOTE_C4, snd#NOTE_Cs4, snd#NOTE_D4, snd#NOTE_Ds4, snd#NOTE_E4, snd#NOTE_F4, snd#NOTE_Fs4, snd#NOTE_G4, snd#NOTE_Gs4, snd#NOTE_A4, snd#NOTE_As4, snd#NOTE_B4
        word snd#NOTE_C5, snd#NOTE_Cs5, snd#NOTE_D5, snd#NOTE_Ds5, snd#NOTE_E5, snd#NOTE_F5, snd#NOTE_Fs5, snd#NOTE_G5, snd#NOTE_Gs5, snd#NOTE_A5, snd#NOTE_As5, snd#NOTE_B5
        word snd#NOTE_C6, snd#NOTE_Cs6, snd#NOTE_D6, snd#NOTE_Ds6, snd#NOTE_E6, snd#NOTE_F6, snd#NOTE_Fs6, snd#NOTE_G6, snd#NOTE_Gs6, snd#NOTE_A6, snd#NOTE_As6, snd#NOTE_B6
            
PUB Main | b, vel, channel, status

  snd.start( 7 )
  midi.start( 16, 17, %0100, 31250 )
  tv.main
  channel := 0

  status := $90
  
  repeat
    b := midi.rx

    if (b <> $FE) and (b <> $F8)

      if (b > $7F)
        status := b
        b := midi.rx
    
      if (status & $F0) == $90
        vel := midi.rx
        if (vel > 0)
          snd.PlaySoundFM(channel, snd#SHAPE_SAWTOOTH, lut[b - 12], snd#SAMPLE_RATE, vel * 2, $013579acf )
          channel ++
          if (channel > 8)
            channel := 0
          tv.PressKey(b)
        else
          tv.ReleaseKey(b)

      if (status & $F0) == $80
        tv.ReleaseKey(b)